Attribute VB_Name = "ParseData"
Option Explicit

Public Sub ParseEvents(ByVal temporaryFile As String, ByVal OutFile As String)
    '// parses calendar events to vCalendar format - we append it to the previous output from ParseCalendar
    '// the fields are:
    '// startdate (min. since 1/1/1904), text, alarmtime (min. since 1/1/1904)
    Dim CurrentInputLine, CurrentOutputLine, EntryCount As String
    Dim FileNum2, foo As Integer
    Dim daStartDate, daAlarmTime, basedate As Date
    Dim daDay, daMonth, daYear, daHour, daMinute, daText, daStartDateString, daAlarmTimeString As String
    
    FileNum = FreeFile
    FileNum2 = FreeFile(1)
    
    Open OutFile For Append As FileNum2
    Open temporaryFile For Input As FileNum
    
    mainform.UpdateStatus ("Parsing Sloup Data...")
    EntryCount = 0
    mainform.Refresh
    
    Print #FileNum2, "BEGIN:VCALENDAR"
    Print #FileNum2, "VERSION:1.0"
    Print #FileNum2, "PRODID:NewtDump " & App.Major & "." & App.Minor
    Print #FileNum2, "TZ:" & mainform.TimeZoneOffset
    
    Do Until EOF(FileNum)
        DoEvents
        basedate = #1/1/1904#
        Line Input #FileNum, CurrentInputLine
        
        If CurrentInputLine = "BYE!" Then Exit Do
        
        Print #FileNum2, "BEGIN:VEVENT"
        Print #FileNum2, "CATEGORIES:EVENT"
        
        '// startdate
        daStartDate = DateAdd("n", CDbl(CurrentInputLine), basedate)
        daMonth = Month(daStartDate)
        If Len(daMonth) = 1 Then
            daMonth = "0" & daMonth
        End If
        
        daDay = Day(daStartDate)
        If Len(daDay) = 1 Then
            daDay = "0" & daDay
        End If
        
        daHour = Hour(daStartDate)
        If Len(daHour) = 1 Then
            daHour = "0" & daHour
        End If
        
        daMinute = Minute(daStartDate)
        If Len(daMinute) = 1 Then
            daMinute = "0" & daMinute
        End If
        
        daStartDateString = Year(daStartDate) & daMonth & daDay & "T" & daHour & daMinute & "00" & mainform.TimeZoneOffset
        
        '// text
        Line Input #FileNum, CurrentInputLine
        daText = CurrentInputLine
        
        '// alarmtime
        daAlarmTimeString = ""
        Line Input #FileNum, CurrentInputLine
        If Not CurrentInputLine = "" Then
            daAlarmTime = DateAdd("n", CDbl(CurrentInputLine), basedate)
            
            daMonth = Month(daAlarmTime)
            If Len(daMonth) = 1 Then
                daMonth = "0" & daMonth
            End If
        
            daDay = Day(daAlarmTime)
            If Len(daDay) = 1 Then
                daDay = "0" & daDay
            End If
        
            daHour = Hour(daAlarmTime)
            If Len(daHour) = 1 Then
                daHour = "0" & daHour
            End If
            
            daMinute = Minute(daAlarmTime)
            If Len(daMinute) = 1 Then
                daMinute = "0" & daMinute
            End If
        
            daAlarmTimeString = Year(daAlarmTime) & daMonth & daDay & "T" & daHour & daMinute & "00" & mainform.TimeZoneOffset
        End If
        
        '// output values to stream
        Print #FileNum2, "DESCRIPTION:" & daText
        Print #FileNum2, "SUMMARY:" & daText
        Print #FileNum2, "DTSTART:" & daStartDateString
        'Print #FileNum2, "DTEND:" & daEndDateString
        If Not daAlarmTimeString = "" Then Print #FileNum2, "DALARM:" & daAlarmTimeString & ";P1H;0;" & daText
        Print #FileNum2, "PRIORITY:0"
        Print #FileNum2, "END:VEVENT"
        
        '// record seperator
        Line Input #FileNum, CurrentInputLine
        EntryCount = EntryCount + 1
    Loop
    
    Print #FileNum2, "END:VCALENDAR"
    
    Close #FileNum
    Close #FileNum2
    mainform.UpdateStatus ("Parse complete.  " & EntryCount & " entries saved.")
    mainform.Refresh
    '// Delete the temporary file
    Kill temporaryFile

End Sub


Public Sub ParseCalendar(ByVal temporaryFile As String, ByVal OutFile As String)
    '// parses calendar entries (meetings) to vCalendar format
    '// the fields are:
    '// type ("meeting"), startdate (min. since 1/1/1904), duration (min), text, alarmtime (min. since 1/1/1904)
    Dim CurrentInputLine, CurrentOutputLine, EntryCount As String
    Dim FileNum2, daDuration, foo As Integer
    Dim daStartDate, daEndDate, daAlarmTime, basedate As Date
    Dim daDay, daMonth, daYear, daHour, daMinute, daText, daStartDateString, daEndDateString, daAlarmTimeString As String
    
    FileNum = FreeFile
    FileNum2 = FreeFile(1)
    
    Open OutFile For Append As FileNum2
    Open temporaryFile For Input As FileNum
    
    mainform.UpdateStatus ("Parsing Sloup Data...")
    EntryCount = 0
    mainform.Refresh
    
    Print #FileNum2, "BEGIN:VCALENDAR"
    Print #FileNum2, "VERSION:1.0"
    Print #FileNum2, "PRODID:NewtDump " & App.Major & "." & App.Minor
    Print #FileNum2, "TZ:" & mainform.TimeZoneOffset
    
    Do Until EOF(FileNum)
        DoEvents
        basedate = #1/1/1904#
        Line Input #FileNum, CurrentInputLine
        
        If CurrentInputLine = "BYE!" Then Exit Do
        
        If Not CurrentInputLine = "meeting" Then
            foo = MsgBox("Invalid meeting entry found: #" & EntryCount, vbCritical)
            'Exit Do
        End If
        
        Print #FileNum2, "BEGIN:VEVENT"
        Print #FileNum2, "CATEGORIES:MEETING"
        
        '// startdate
        Line Input #FileNum, CurrentInputLine
        daStartDate = DateAdd("n", CDbl(CurrentInputLine), basedate)
        daMonth = Month(daStartDate)
        If Len(daMonth) = 1 Then
            daMonth = "0" & daMonth
        End If
        
        daDay = Day(daStartDate)
        If Len(daDay) = 1 Then
            daDay = "0" & daDay
        End If
        
        daHour = Hour(daStartDate)
        If Len(daHour) = 1 Then
            daHour = "0" & daHour
        End If
        
        daMinute = Minute(daStartDate)
        If Len(daMinute) = 1 Then
            daMinute = "0" & daMinute
        End If
        
        daStartDateString = Year(daStartDate) & daMonth & daDay & "T" & daHour & daMinute & "00" & mainform.TimeZoneOffset
        
        '// duration (end date)
        Line Input #FileNum, CurrentInputLine
        daDuration = CInt(CurrentInputLine)
        daEndDate = DateAdd("n", CDbl(CurrentInputLine), daStartDate)
        
        daMonth = Month(daEndDate)
        If Len(daMonth) = 1 Then
            daMonth = "0" & daMonth
        End If
        
        daDay = Day(daEndDate)
        If Len(daDay) = 1 Then
            daDay = "0" & daDay
        End If
        
        daHour = Hour(daEndDate)
        If Len(daHour) = 1 Then
            daHour = "0" & daHour
        End If
        
        daMinute = Minute(daEndDate)
        If Len(daMinute) = 1 Then
            daMinute = "0" & daMinute
        End If
        
        daEndDateString = Year(daEndDate) & daMonth & daDay & "T" & daHour & daMinute & "00" & mainform.TimeZoneOffset
        
        '// text
        Line Input #FileNum, CurrentInputLine
        daText = CurrentInputLine
        
        '// alarmtime
        daAlarmTimeString = ""
        Line Input #FileNum, CurrentInputLine
        If Not CurrentInputLine = "" Then
            daAlarmTime = DateAdd("n", CDbl(CurrentInputLine), basedate)
            
            daMonth = Month(daAlarmTime)
            If Len(daMonth) = 1 Then
                daMonth = "0" & daMonth
            End If
        
            daDay = Day(daAlarmTime)
            If Len(daDay) = 1 Then
                daDay = "0" & daDay
            End If
        
            daHour = Hour(daAlarmTime)
            If Len(daHour) = 1 Then
                daHour = "0" & daHour
            End If
            
            daMinute = Minute(daAlarmTime)
            If Len(daMinute) = 1 Then
                daMinute = "0" & daMinute
            End If
        
            daAlarmTimeString = Year(daAlarmTime) & daMonth & daDay & "T" & daHour & daMinute & "00" & mainform.TimeZoneOffset
        End If
        
        '// output values to stream
        Print #FileNum2, "DESCRIPTION:" & daText
        Print #FileNum2, "SUMMARY:" & daText
        Print #FileNum2, "DTSTART:" & daStartDateString
        Print #FileNum2, "DTEND:" & daEndDateString
        If Not daAlarmTimeString = "" Then Print #FileNum2, "DALARM:" & daAlarmTimeString
        Print #FileNum2, "PRIORITY:0"
        Print #FileNum2, "END:VEVENT"
        
        '// record seperator
        Line Input #FileNum, CurrentInputLine
        EntryCount = EntryCount + 1
    Loop
    
    Print #FileNum2, "END:VCALENDAR"
    
    Close #FileNum
    Close #FileNum2
    mainform.UpdateStatus ("Parse complete.  " & EntryCount & " entries saved.")
    mainform.Refresh
    '// Delete the temporary file
    Kill temporaryFile

End Sub

Public Sub ParseCSVNames(ByVal temporaryFile As String, ByVal OutFile As String)
    '// parses names date to CSV format
    '// the fields are:
    '// FirstName, LastName, Name, Title, PrimaryPhone, WorkPhone, BeeperPhone, FaxPhone, EMail, Address1, Address2,
    '// City, Province, Country, PostCode, BirthDate, BDDay, BDMonty, BDYear
    Dim CurrentInputLine As String
    Dim CurrentOutputLine As String
    Dim EntryCount As String
    Dim FileNum2 As Integer
    
    Dim daDay, daMonth, daYear, daRawTime, daHour, daMinute, CardType, Salutation, FirstName, LastName, Title, BusName, _
        PrimaryPhone, WorkPhone, BeeperPhone, FaxPhone, EMailAddress, Address1, Address2, City, Province, Country, _
        PostCode, BirthDate, BDDay, BDMonth, BDYear As String
    FileNum = FreeFile
    FileNum2 = FreeFile(1)
    
    Open OutFile For Append As FileNum2
    Open temporaryFile For Input As FileNum
    
    mainform.UpdateStatus ("Parsing Sloup Data...")
    EntryCount = 0
    mainform.Refresh
    
    Print #FileNum2, "FirstName,LastName,Name,Title,BusName,PrimaryPhone,WorkPhone,BeeperPhone,FaxPhone,EMail,Address,City,Province,Country,PostCode,BDDay,BDMonth,BDYear"
    
    Do Until EOF(FileNum)
        '// date
        Line Input #FileNum, CurrentInputLine
        
        If CurrentInputLine = "BYE!" Then Exit Do

        '// card type
        Line Input #FileNum, CurrentInputLine
        CardType = CurrentInputLine
        
        '// salutation
        Line Input #FileNum, CurrentInputLine
        Salutation = CurrentInputLine
        
        '// first name
        Line Input #FileNum, CurrentInputLine
        FirstName = CurrentInputLine
        
        '// last name
        Line Input #FileNum, CurrentInputLine
        LastName = CurrentInputLine
        
        '// title
        Line Input #FileNum, CurrentInputLine
        Title = CurrentInputLine
                
        '// business name
        Line Input #FileNum, CurrentInputLine
        BusName = CurrentInputLine
        
        If CardType = "person" Or CardType = "owner" Then
            CurrentOutputLine = FirstName & "," & LastName & "," & Salutation & " " & FirstName & " " & LastName & "," & Title & "," & BusName & ","
        End If
        If CardType = "company" Then
            CurrentOutputLine = ",," & BusName & ",," & BusName & ","
        End If
        
        '// primary home/business phone number
        Line Input #FileNum, CurrentInputLine
        PrimaryPhone = CurrentInputLine
        
        '// work phone number
        Line Input #FileNum, CurrentInputLine
        WorkPhone = CurrentInputLine
        
        '// pager/cell phone number
        Line Input #FileNum, CurrentInputLine
        BeeperPhone = CurrentInputLine
        
        '// fax phone number
        Line Input #FileNum, CurrentInputLine
        FaxPhone = CurrentInputLine
        
        CurrentOutputLine = CurrentOutputLine & PrimaryPhone & "," & WorkPhone & "," & BeeperPhone & "," & FaxPhone & ","
        
        '// e-mail address
        Line Input #FileNum, CurrentInputLine
        EMailAddress = CurrentInputLine

        CurrentOutputLine = CurrentOutputLine & EMailAddress & ","

        '// first line of address
        Line Input #FileNum, CurrentInputLine
        Address1 = CurrentInputLine
        
        '// second line of address
        Line Input #FileNum, CurrentInputLine
        Address2 = CurrentInputLine
        
        '// city
        Line Input #FileNum, CurrentInputLine
        City = CurrentInputLine
        
        '// province/state
        Line Input #FileNum, CurrentInputLine
        Province = CurrentInputLine
        
        '// country
        Line Input #FileNum, CurrentInputLine
        Country = CurrentInputLine
        
        '// postal code
        Line Input #FileNum, CurrentInputLine
        PostCode = CurrentInputLine
        
        CurrentOutputLine = CurrentOutputLine & Address1 & " " & Address2 & "," & City & "," & Province & "," & Country & "," & PostCode & ","
                
        '// birthdate
        Line Input #FileNum, CurrentInputLine
        BirthDate = CurrentInputLine
        
        If Not BirthDate = "" Then
            BDDay = Piece(BirthDate, "/", 2, 2)
            If Len(BDDay) = 1 Then
                BDDay = "0" & BDDay
            End If
            BDMonth = Piece(BirthDate, "/", 1, 1)
            If Len(BDMonth) = 1 Then
                BDMonth = "0" & BDMonth
            End If
            BDYear = Piece(BirthDate, "/", 3, 3)
            If Len(BDYear) = 1 Then
                BDYear = "0" & BDYear
            End If
            If CInt(BDYear) < 10 Then
                BDYear = "20" & BDYear
            ElseIf CInt(BDYear) > 9 Then
                BDYear = "19" & BDYear
            End If
        
            CurrentOutputLine = CurrentOutputLine & BDDay & "," & BDMonth & "," & BDYear
        Else
            CurrentOutputLine = CurrentOutputLine & ",,"
        End If
        
        Print #FileNum2, CurrentOutputLine

        '// record seperator
        Line Input #FileNum, CurrentInputLine
        EntryCount = EntryCount + 1
    Loop
    
    Close #FileNum
    Close #FileNum2
    mainform.UpdateStatus ("Parse complete.  " & EntryCount & " entries saved.")
    mainform.Refresh
    '// Delete the temporary file
    Kill temporaryFile
End Sub


Public Sub ParseNames(ByVal temporaryFile As String, ByVal OutFile As String)
    '// This subroutine will parse the names data from Sloup into a VCF stream
    '// Sloup data looks like this:
    '// <month> <day> <year> <hours:minutes>
    '// type of card: <owner|person|company>
    '// salutation (eg. Mr.)
    '// first name
    '// last name
    '// title
    '// company name (if type of card is company)
    '// home/business phone number (primary)
    '// work phone number
    '// pager/cell phone number
    '// fax number
    '// e-mail address
    '// address
    '// 2nd line of address
    '// city
    '// province/state/region
    '// country
    '// zip/postal code
    '// birthdate
    '// record delimiter <|||||>
    Dim CurrentInputLine As String
    Dim CurrentOutputLine As String
    Dim EntryCount As Integer
    Dim FileNum2 As Integer
    Dim daDay, daMonth, daYear, daRawTime, daHour, daMinute, CardType, Salutation, FirstName, LastName, Title, BusName, _
        PrimaryPhone, WorkPhone, BeeperPhone, FaxPhone, EMailAddress, Address1, Address2, City, Province, Country, _
        PostCode, BirthDate, BDDay, BDMonth, BDYear As String
    FileNum = FreeFile
    FileNum2 = FreeFile(1)
    
    Open OutFile For Append As FileNum2
    Open temporaryFile For Input As FileNum
    
    mainform.UpdateStatus ("Parsing Sloup Data...")
    EntryCount = 0
    mainform.Refresh
    
    Do Until EOF(FileNum)
        
        '// date
        Line Input #FileNum, CurrentInputLine
        
        If CurrentInputLine = "BYE!" Then
            Exit Do
        End If
        
        Print #FileNum2, "BEGIN:VCARD"
        Print #FileNum2, "VERSION:2.1"
                
        daDay = Piece(CurrentInputLine, " ", 1, 1)
        If Len(daDay) = 1 Then
            daDay = "0" & daDay
        End If
        daMonth = Piece(CurrentInputLine, " ", 2, 2)
        If Len(daMonth) = 1 Then
            daMonth = "0" & daMonth
        End If
        daYear = Piece(CurrentInputLine, " ", 3, 3)
        daRawTime = Piece(CurrentInputLine, " ", 4, 4)
        daHour = Piece(daRawTime, ":", 1, 1)
        If Len(daHour) = 1 Then
            daHour = "0" & daHour
        End If
        daMinute = Piece(daRawTime, ":", 1, 1)
        If Len(daMinute) = 1 Then
            daMinute = "0" & daMinute
        End If
        CurrentOutputLine = "REV:" & daYear & daMonth & daDay & "T" & daHour & daMinute & "00"
        Print #FileNum2, CurrentOutputLine
        CurrentOutputLine = ""
        
        '// card type
        Line Input #FileNum, CurrentInputLine
        CardType = CurrentInputLine
        
        '// salutation
        Line Input #FileNum, CurrentInputLine
        Salutation = CurrentInputLine
        
        '// first name
        Line Input #FileNum, CurrentInputLine
        FirstName = CurrentInputLine
        
        '// last name
        Line Input #FileNum, CurrentInputLine
        LastName = CurrentInputLine
        
        '// title
        Line Input #FileNum, CurrentInputLine
        Title = CurrentInputLine
        
        CurrentOutputLine = "TITLE:" & Title
        Print #FileNum2, CurrentOutputLine
        
        '// business name
        Line Input #FileNum, CurrentInputLine
        BusName = CurrentInputLine
        
        If CardType = "person" Or CardType = "owner" Then
            CurrentOutputLine = "FN:" & Salutation & " " & FirstName & " " & LastName
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "N:" & LastName & ";" & FirstName & ";;" & Salutation
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "ORG:" & BusName
            Print #FileNum2, CurrentOutputLine
        End If
        If CardType = "company" Then
            CurrentOutputLine = "FN:" & BusName
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "ORG:" & BusName
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "N:;" & BusName & ";;"
            Print #FileNum2, CurrentOutputLine
        End If
        
        '// primary home/business phone number
        Line Input #FileNum, CurrentInputLine
        PrimaryPhone = CurrentInputLine
        
        '// work phone number
        Line Input #FileNum, CurrentInputLine
        WorkPhone = CurrentInputLine
        
        '// pager/cell phone number
        Line Input #FileNum, CurrentInputLine
        BeeperPhone = CurrentInputLine
        
        '// fax phone number
        Line Input #FileNum, CurrentInputLine
        FaxPhone = CurrentInputLine
        
        If CardType = "person" Or CardType = "owner" Then
            CurrentOutputLine = "TEL;HOME;VOICE:" & PrimaryPhone
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "TEL;WORK;VOICE:" & WorkPhone
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "TEL;CELL;VOICE:" & BeeperPhone
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "TEL;HOME;FAX:" & FaxPhone
            Print #FileNum2, CurrentOutputLine
        End If
        If CardType = "company" Then
            CurrentOutputLine = "TEL;WORK;VOICE:" & PrimaryPhone
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "TEL;HOME;VOICE:" & PrimaryPhone
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "TEL;WORK;FAX:" & FaxPhone
            Print #FileNum2, CurrentOutputLine
        End If
        
        '// e-mail address
        Line Input #FileNum, CurrentInputLine
        EMailAddress = CurrentInputLine

        CurrentOutputLine = "EMAIL;PREF;INTERNET:" & EMailAddress
        Print #FileNum2, CurrentOutputLine

        '// first line of address
        Line Input #FileNum, CurrentInputLine
        Address1 = CurrentInputLine
        
        '// second line of address
        Line Input #FileNum, CurrentInputLine
        Address2 = CurrentInputLine
        
        '// city
        Line Input #FileNum, CurrentInputLine
        City = CurrentInputLine
        
        '// province/state
        Line Input #FileNum, CurrentInputLine
        Province = CurrentInputLine
        
        '// country
        Line Input #FileNum, CurrentInputLine
        Country = CurrentInputLine
        
        '// postal code
        Line Input #FileNum, CurrentInputLine
        PostCode = CurrentInputLine
        
        If CardType = "owner" Or CardType = "person" Then
            CurrentOutputLine = "ADR;HOME:;;" & Address1 & " " & Address2 & ";" & City & ";" & Province & ";" _
                & PostCode & ";" & Country
            Print #FileNum2, CurrentOutputLine
            CurrentOutputLine = "LABEL;HOME;ENCODING=QUOTED-PRINTABLE:" & Address1 & " " & Address2 & "=0D=0A" _
                & City & ", " & Province & " " & PostCode & "=0D=0A" & Country
            Print #FileNum2, CurrentOutputLine
        End If
        If CardType = "company" Then
        
        End If
        
        '// birthdate
        Line Input #FileNum, CurrentInputLine
        BirthDate = CurrentInputLine
        
        If Not BirthDate = "" Then
            BDDay = Piece(BirthDate, "/", 2, 2)
            If Len(BDDay) = 1 Then
                BDDay = "0" & BDDay
            End If
            BDMonth = Piece(BirthDate, "/", 1, 1)
            If Len(BDMonth) = 1 Then
                BDMonth = "0" & BDMonth
            End If
            BDYear = Piece(BirthDate, "/", 3, 3)
            If Len(BDYear) = 1 Then
                BDYear = "0" & BDYear
            End If
            If CInt(BDYear) < 10 Then
                BDYear = "20" & BDYear
            ElseIf CInt(BDYear) > 9 Then
                BDYear = "19" & BDYear
            End If
        
            CurrentOutputLine = "BDAY:" & BDYear & BDDay & BDMonth
            Print #FileNum2, CurrentOutputLine
        End If
        
        Print #FileNum2, "X-GENERATOR:NewtDump " & mainform.versionstring
        Print #FileNum2, "END:VCARD"
        
        '// record seperator
        Line Input #FileNum, CurrentInputLine
        
        EntryCount = EntryCount + 1
        
    Loop
    
    Close #FileNum
    Close #FileNum2
    mainform.UpdateStatus ("Parse complete.  " & EntryCount & " entries saved.")
    mainform.Refresh
    '// Delete the temporary file
    Kill temporaryFile
End Sub

Public Sub ParseQuotes(ByVal temporaryFile As String, ByVal OutFile As String)
    '// Parses quotes data from sloup into a text file
    '// data looks like this:
    '// author name
    '// source
    '// quote (multiple lines?)
    '// |||||
    
    Dim CurrentInputLine As String
    Dim CurrentOutputLine As String
    Dim EntryCount As Integer
    Dim FileNum2 As Integer
    FileNum = FreeFile
    FileNum2 = FreeFile(1)
    EntryCount = 0
    
    Open temporaryFile For Input As FileNum
    Open OutFile For Append As FileNum2
    
    mainform.UpdateStatus ("Parsing Quotes data...")
    mainform.Refresh
    
    Do Until EOF(FileNum)
        '// read in author name
        Line Input #FileNum, CurrentInputLine
        If CurrentInputLine = "BYE!" Then
            Exit Do
        End If
        If CurrentInputLine = "" Then
            Print #FileNum2, "Author: unknown"
        Else
            Print #FileNum2, "Author: " & CurrentInputLine
        End If
        
        '// read in source
        Line Input #FileNum, CurrentInputLine
        If CurrentInputLine = "" Then
            Print #FileNum2, "Source: unknown"
        Else
            Print #FileNum2, "Source: " & CurrentInputLine
        End If
        
        '// read the quote
        Print #FileNum2, "Quote:"
        Do While (1) 'wow, this is an evil thing to do
            Line Input #FileNum, CurrentInputLine
            If CurrentInputLine = "|||||" Then
                Exit Do
            ElseIf EOF(FileNum) Or CurrentInputLine = "BYE!" Then
                Exit Sub
            End If
            Print #FileNum2, CurrentInputLine
        Loop
        
        Print #FileNum2, "------------------------------"
        '// that's it!  not as painful as I thought it was going to be.  just ugly.
        EntryCount = EntryCount + 1
    Loop
    Close #FileNum
    Close #FileNum2
    mainform.UpdateStatus ("Parse complete.  " & EntryCount & " entries saved.")
    mainform.Refresh
    '// Delete the temporary file
    Kill temporaryFile
    
End Sub

Public Sub ParseIOB(ByVal temporaryFile As String, ByVal OutFile As String)
    '// This subroutine will parse the in/outbox data from Sloup into a standard folder file
    '// Sloup data looks like this:
    '// (blank line)
    '// fake date - we throw this out
    '// Long Time format (eg. "Wed Oct 27 12:22:23 pm EDT 2000")
    '// Sender's First Name
    '// Sender's last name
    '// Sender's e-mail address
    '// Recipient's First Name
    '// Recipient's Last Name
    '// Recpipent's e-mail address
    '// Subject line
    '// (message body)
    '// ||||| <- denotes end of message
    
    '// date lines:
    '// From - Mon May 28 14:30:00 2001
    '// Date: Mon, 28 May 2001 14:30:00 -0400 (EDT)
    
    '// From MAILER-DAEMON Mon Jun  4 15:13:12 2001
    '// Date: Mon, 4 Jun 2001 15:13:12 -0400 (EDT)

    
    Dim CurrentInputLine As String
    Dim CurrentOutputLine As String
    Dim FirstName As String, LastName As String, EMail As String
    Dim ToCounter As Integer
    Dim BaseFileName As String
    Dim EntryCount As Integer
    Dim FileNum2 As Integer
    FileNum = FreeFile
    FileNum2 = FreeFile(1)
    EntryCount = 0
    
    Open temporaryFile For Input As FileNum
    Open OutFile For Append As FileNum2
    
    mainform.UpdateStatus ("Parsing Sloup Data...")
    mainform.Refresh
    
    Do Until EOF(FileNum)
        '// TOP OF INPUT FILE / TOP OF MESSAGE RECORD
        '// read a line in from the file
        Line Input #FileNum, CurrentInputLine
        '// if the line is empty, keep reading until we find the beginning of the message
        While CurrentInputLine = ""
            Line Input #FileNum, CurrentInputLine
        Wend
        
        If CurrentInputLine = "BYE!" Then
            Exit Do
        End If
        
        '// this is the first date - we throw it out
        '// read in the real valid date
        Line Input #FileNum, CurrentInputLine
        '// add the time zone to the date and spit out the From line
        CurrentOutputLine = "From - " & Piece(CurrentInputLine, ",", 1, 1) & Piece(CurrentInputLine, ",", 2, 2)
        '& " " & mainform.TimeZoneCode
        Print #FileNum2, CurrentOutputLine
        '// need to split up outputline
        CurrentOutputLine = "Date: " & Piece(CurrentInputLine, " ", 1, 1) & " " & Piece(CurrentInputLine, " ", 3, 3) _
            & " " & Piece(CurrentInputLine, " ", 2, 2) & " " & Piece(CurrentInputLine, " ", 5, 5) & " " _
            & Piece(CurrentInputLine, " ", 4, 4) & " " & mainform.TimeZoneOffset & "00 (" & mainform.TimeZoneCode & ")"
        Print #FileNum2, CurrentOutputLine
        
        CurrentOutputLine = ""
        
        '// this is the sender's name
        '// the first and last names are on seperate lines - one or more may be blank
        Line Input #FileNum, CurrentInputLine
        CurrentOutputLine = "From: " & CurrentInputLine
        Line Input #FileNum, CurrentInputLine
        CurrentOutputLine = CurrentOutputLine & " " & CurrentInputLine
        '// get the sender's e-mail address
        Line Input #FileNum, CurrentInputLine
        CurrentOutputLine = CurrentOutputLine & " <" & CurrentInputLine & ">"
        '// print the From: line to the file
        Print #FileNum2, CurrentOutputLine
        CurrentOutputLine = ""
        
        '// get the subject line and print output it
        Line Input #FileNum, CurrentInputLine
        Print #FileNum2, "Subject: " & CurrentInputLine
        
        '// get the recipient's first name, last name, e-mail, concatenate them together and output it
        '// FIXMEFIXME - we don't handle multiple recipients correctly.  To fix this, we need to:
        '// -read in the three lines (FirstName, LastName, EMail)
        '// -check to see that the EMail has an "@" symbol in it (is a valid e-mail address
        '// -if so, then this is an e-mail recipient - add to the To line
        '// -if NOT, then we are done reading recipients and are on to the body - add it to the body
        CurrentOutputLine = CurrentOutputLine & "To: "
        ToCounter = 0
        '// read in the data
beginRecipients:
        Line Input #FileNum, FirstName
        Line Input #FileNum, LastName
        Line Input #FileNum, EMail
        If EMail Like "*@*.*" Then
            ' this is an e-mail address - therefore this is a recipient.
            If ToCounter > 0 Then CurrentOutputLine = CurrentOutputLine & ", "
            CurrentOutputLine = CurrentOutputLine & FirstName & " " & LastName & " <" & EMail & ">"
            ToCounter = ToCounter + 1
            GoTo beginRecipients
        Else
            ' this is not an e-mail address - therefore we're in the BODY.
            ' print the recipients we've got
            Print #FileNum2, CurrentOutputLine
            ' add some whitespace to make it look purty
            Print #FileNum2,
            ' print the part of the body we just snarfed
            Print #FileNum2, FirstName
            Print #FileNum2, LastName
            Print #FileNum2, EMail
        End If
        
        'Line Input #FileNum, CurrentInputLine
        'CurrentOutputLine = CurrentOutputLine & "To: " & CurrentInputLine & " "
        'Line Input #FileNum, CurrentInputLine
        'CurrentOutputLine = CurrentOutputLine & CurrentInputLine & " "
        'Line Input #FileNum, CurrentInputLine
        'CurrentOutputLine = CurrentOutputLine & "<" & CurrentInputLine & ">"
        'Print #FileNum2, CurrentOutputLine
        CurrentOutputLine = ""
        
        '// read the rest of the lines (message body) and print them out until we hit the special line
        Do While (1) 'wow, this is an evil thing to do
            Line Input #FileNum, CurrentInputLine
            If CurrentInputLine = "|||||" Then
                Exit Do
            ElseIf EOF(FileNum) Or CurrentInputLine = "BYE!" Then
                Exit Sub
            End If
            Print #FileNum2, CurrentInputLine
        Loop
        
        Print #FileNum2, ""
        '// that's it!  not as painful as I thought it was going to be.  just ugly.
        EntryCount = EntryCount + 1
    Loop
    Close #FileNum
    Close #FileNum2
    mainform.UpdateStatus ("Parse complete.  " & EntryCount & " entries saved.")
    mainform.Refresh
    '// Delete the temporary file
    Kill temporaryFile
End Sub

